;
;   LAUNCHER -  
;      ணࠬ ᮢᥬ  ⨬஢,  祭   .
;       㧨 ଠ  ணࠬ  ᪠  䠩
;     AUTORUN.DAT. ଠ 祭      㦤.
;
;      FASM 1.52  
;
include "MACROS.INC"

  use32
  org    0x0
  db     'MENUET01'              ; 8 byte id
  dd     0x01                    ; header version
  dd     START                   ; start of code
  dd     I_END                   ; size of image
  dd     0x80000                 ; memory for app
  dd     0x80000                 ; esp
  dd     0x0 , 0x0               ; I_Param , I_Icon

;include "DEBUG.INC"

START:                           ; start of execution

   mov  eax, 5
   mov  ebx, 10
   int  0x40

   mov  eax, 58               ; load AUTORUN.DAT
   mov  ebx, autorun_dat_info
   int  0x40

   call get_number
   mov  [number_of_files], eax
;dps "NUMBER OF FILES: "
;dpd eax
;dps <13,10>
   call next_line

 start_program:
;dps <"STARTING A PROGRAM",13,10>
   call clear_strings
   mov  edi, program
   call get_string
   mov  edi, parameters
   call get_string
   call get_number
   call run_program
   call next_line
   dec  [number_of_files]
   jnz  start_program

 exit:
   or   eax, -1
   int  0x40


 run_program:     ; time to delay in eax
   push eax
   mov  eax, 19
   mov  ebx, program
   mov  ecx, parameters
   int  0x40
   pop  ebx

   mov  eax, 5
   int  0x40
 ret


 clear_strings:   ; clears buffers
   pushad

   mov  ecx, 50
   mov  edi, program
   mov  al, ' '
   rep  stosb

   mov  ecx, 50
   mov  edi, parameters
   xor  al,al
   rep  stosb

   popad
 ret


 get_string: ; pointer to destination buffer in edi
   pushad
   call skip_spaces
   mov  esi, [position]
;dpd esi
;dps <13,10>
   add  esi, file_data
  .start:
   lodsb
   cmp  al, ' '
   je   .finish
   stosb
   inc  [position]
   jmp  .start
  .finish:
   popad
 ret


 get_number:
   push ebx esi
   call skip_spaces
   mov  esi, [position]
   add  esi, file_data
   xor  eax, eax
   xor  ebx, ebx
  .start:
   lodsb
   cmp  al, '0'
   jb   .finish
   cmp  al, '9'
   ja   .finish
   sub  al, '0'
   imul ebx, 10
   add  ebx, eax
   inc  [position]
   jmp  .start
  .finish:
   mov  eax, ebx
   pop  esi ebx
 ret


 skip_spaces:
   pushad
   xor  eax, eax
   mov  esi, [position]
   add  esi, file_data
  .start:
   lodsb
   cmp  al, ' '
   jne  .finish
   inc  [position]
   jmp  .start
  .finish:
;dps "NOW AL = "
;mov [tmp],al
;mov edx, tmp
;call debug_outstr
;dps <13,10>
   popad
 ret


 next_line:
   pushad
   mov  esi, [position]
   add  esi, file_data
  .start:
   lodsb
   cmp  al, 13
   je   .finish
   inc  [position]
   jmp  .start
  .finish:
   add  [position], 2
   inc  esi
   lodsb
   cmp  al, '#'
   jne  .nocomment
   call next_line
  .nocomment:
   popad
 ret



; DATA:
 autorun_dat_info:                 ; AUTORUN.DAT
   .mode           dd 0            ; read file
   .start_block    dd 0            ; block to read
   .blocks         dd 0x10         ; 16*512 bytes max
   .address        dd file_data
   .workarea       dd work_area
   db "/RD/1/AUTORUN.DAT",0

 position          dd 0            ; position in file
I_END:
 number_of_files   dd ?

 program           rb 50
 parameters        rb 50

 work_area         rb 0x10000
 file_data         rb 16*512
